#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>

#define MAXVALENCE 10

class Point
{
public:

  double x,y,z;
  int    valence;
  int    ID;
  int    adjacent[MAXVALENCE];

  Point(){x=0.0;y=0.0;z=0.0;valence=0;}
  Point(FILE *f);
};

class Quad
{
public:

  int   p[4];
  Quad *NQ[4];

  int   centerP;
  int   edgeP[4];

  int has_point(int i)
    {
      if(p[0]==i) return 1;
      if(p[1]==i) return 1;
      if(p[2]==i) return 1;
      if(p[3]==i) return 1;
      return(0);
    }
  void set_neighbor(Quad *N, int p1, int p2, int npc);

  void save(FILE *f)
    {
      fprintf(f,"%d %d %d %d\n",p[0],edgeP[0],centerP,edgeP[3]);
      fprintf(f,"%d %d %d %d\n",p[1],edgeP[1],centerP,edgeP[0]);
      fprintf(f,"%d %d %d %d\n",p[2],edgeP[2],centerP,edgeP[1]);
      fprintf(f,"%d %d %d %d\n",p[3],edgeP[3],centerP,edgeP[2]);
    }

  Quad(FILE *f);
};

class Mesh
{
public:
  int numpatches, numpoints;
  int new_numpoints;

  Quad  **Q;
  Point **P;

  Point **NP;
  int   npc;

  void set_valences(void);
  void set_neighbors(void);

  void export_IV(char *fname);
  void save(char *fname);

  Mesh(FILE *f);
  //~Mesh();
};
