//////////////////////////////////////////////////////////////////////////////
// 
// MatrixDiff.cpp, 09/26/01, Ilja Friedel
//
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <iostream.h>

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void load_matrix(char *fname, double *p, int n, int m)
{
  int  i,j;
  FILE *f;

  printf("%s  %d,%d\n",fname,n,m);

  f=fopen(fname,"r");
  if(!f)
    {
      cerr << "Error: File '"<<fname<<"' doesn't exist! (load_matrix())" <<endl;
      exit(1);
    }

  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	{
	  fscanf(f,"%lf",&(p[i*m+j]));  // was i*n+j
	  //printf("%1.3lf ",p[i*n+j]);fflush(0);
	}
      fscanf(f,"\n");
      //      printf("\n");
    }
  fclose(f);
}

//////////////////////////////////////////////////////////////////////////////

void save_matrix(char *fname, double *p, int n, int m)
{
  int i,j;
  FILE *f;

  f=fopen(fname,"w");
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	{
	  fprintf(f,"%1.10e\t",p[i*m+j]);  // was i*n+j
	}
      fprintf(f,"\n");
    }
  fclose(f);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

int main(int argc, char **argv)
{
  double A[65536];
  double B[65536];
  double diff[65536];
  int N, M;
  int i;

  if(argc!=6)
    {
      cerr<<argv[0]<<" file_matrix_A  file_matrix_B  file_diff  N M" << endl;
      exit(1);
    }

  N=atoi(argv[4]);
  M=atoi(argv[5]);

  load_matrix(argv[1],A,N,M);
  load_matrix(argv[2],B,N,M);

  for(i=0;i<N*M;i++)
    {
      diff[i]=A[i]-B[i];
      if(fabs(diff[i]<1e-6)) diff[i]=0.0;
    }

  save_matrix(argv[3],diff,N,M);

  return(1);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
