//////////////////////////////////////////////////////////////////////////////
//
// 
//
//
//////////////////////////////////////////////////////////////////////////////

#include "Minimizer.h"

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
Minimizer::~Minimizer()
{

}

//////////////////////////////////////////////////////////////////////////////

Minimizer::Minimizer()
{

}

//////////////////////////////////////////////////////////////////////////////
// compute C=A+B
void Minimizer::add(double *A, double *B, double *C)
{
  int i;

  for(i=0;i<3*numpoints;i++) 
    {
      C[i]=A[i]+B[i];
      i++;
      C[i]=A[i]+B[i];
      i++;
      C[i]=A[i]+B[i];
    }
};
//////////////////////////////////////////////////////////////////////////////
// compute C=A-B
void Minimizer::sub(double *A, double *B, double *C)
{
  int i;

  for(i=0;i<3*numpoints;i++) 
    {
      C[i]=A[i]-B[i];
      i++;
      C[i]=A[i]-B[i];
      i++;
      C[i]=A[i]-B[i];
    }
}

//////////////////////////////////////////////////////////////////////////////
// compute the scalar product A*B
double Minimizer::dot(double *A, double *B)
{
  int i;
  double tmp;

  tmp=0.0;
  for(i=0;i<3*numpoints;i++) 
    {
      tmp+=A[i]*B[i];
      i++;
      tmp+=A[i]*B[i];
      i++;
      tmp+=A[i]*B[i];
    }
  return(tmp);
}

//////////////////////////////////////////////////////////////////////////////
// compute A=s*A
void Minimizer::scale(double s, double *A)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      A[i]=s*A[i];
      i++;
      A[i]=s*A[i];
      i++;
      A[i]=s*A[i];
    }
}

//////////////////////////////////////////////////////////////////////////////
// compute C=A+s*B for all points
void Minimizer::scale_add(double *A, double s, double *B, double *C)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      C[i]=A[i]+s*B[i];
      i++;
      C[i]=A[i]+s*B[i];
      i++;
      C[i]=A[i]+s*B[i];
    }
}

//////////////////////////////////////////////////////////////////////////////
// compute C=a*A+b*B for all points
void Minimizer::scale_add(double a, double *A, double b, double *B, double *C)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      C[i]=a*A[i]+b*B[i];
      i++;
      C[i]=a*A[i]+b*B[i];
      i++;
      C[i]=a*A[i]+b*B[i];
    }
}

//////////////////////////////////////////////////////////////////////////////
// copy point coordinates from A to B
void Minimizer::copy(double *A, double *B)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      B[i]=A[i];
      i++;
      B[i]=A[i];
      i++;
      B[i]=A[i];
    }
}

//////////////////////////////////////////////////////////////////////////////
// negate copy point coordinates from A to B
void Minimizer::ncopy(double *A, double *B)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      B[i]=-A[i];
      i++;
      B[i]=-A[i];
      i++;
      B[i]=-A[i];
    }
}

//////////////////////////////////////////////////////////////////////////////
// negate coordinates of all points
void Minimizer::neg(double *A)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      A[i]=-A[i];
      i++;
      A[i]=-A[i];
      i++;
      A[i]=-A[i];
    }
}

//////////////////////////////////////////////////////////////////////////////

void Minimizer::set(double *A, double val)
{
  int i;
  for(i=0;i<3*numpoints;i++) 
    {
      A[i]=val;
      i++;
      A[i]=val;
      i++;
      A[i]=val;
    }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

