//////////////////////////////////////////////////////////////////////////////
//
// DynamicCompCol_Mat_double.h
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef DynamicCompCol_Mat_double_H
#define DynamicCompCol_Mat_double_H

//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <math.h>

//////////////////////////////////////////////////////////////////////////////
// list of elements

class DCCMdElement
{
 public:

  double val;
  int    row;
  DCCMdElement *next;

  DCCMdElement(DCCMdElement *DE, int i, double v);
};

//////////////////////////////////////////////////////////////////////////////

class DynamicCompCol_Mat_double
{
  int dim_;
  int NumNonZeros_;
  DCCMdElement **col; // each col sorted list of DCCMdElement

 public:

  DCCMdElement* find(int i, int j) const;

  double operator() (int i, int j) const
    {
      DCCMdElement *DE;

      DE=find(i,j);
      if(DE) return(DE->val);
      else   return(0.0);
    }

  void set(int i, int j, double v);
  void add(int i, int j, double v);

  void save(char *fname); 
  void clear_from_zeros(void);

  int    *row_ind(void);
  int    *col_ptr(void);
  double *val(void);

  int dim(void) {return dim_;}
  int NumNonZeros(){return NumNonZeros_;}

  void mult(double *x, double *result);
  void Cholesky(void);

  ~DynamicCompCol_Mat_double();
  DynamicCompCol_Mat_double(int d);
};

//////////////////////////////////////////////////////////////////////////////

#endif


