//////////////////////////////////////////////////////////////////////////
//
// List.cpp, Ilja Friedel, 06/22/02
//
//////////////////////////////////////////////////////////////////////////

#include "List.h"
#include "Mesh.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

List::~List()
{
  Node *O;

  while(NumElements_>0)
    {
      O=head_->data;
      remove(O);
    }
};

//////////////////////////////////////////////////////////////////////////

List::List()
{
  head_=NULL;
  tail_=NULL;
  NumElements_=0;
}

//////////////////////////////////////////////////////////////////////////

void List::print(void)
{
  ListElement *N;
  
  N=head();
  while(N)
    {
      cout << N->data->ID << " ";
      N=N->next;
    }      
  cout << endl;
}

//////////////////////////////////////////////////////////////////////////

void List::remove(Node* O)
{
  ListElement *p;

  p=head_;
  while(p)
    {
      if(p->data==O)
	{
	  if(p->prev)
	    {
	      p->prev->next=p->next;
	    }
	  else
	    {
	      head_=p->next;
	      if(p->next) p->next->prev=NULL;
	    }
	  if(p->next)
	    {
	      p->next->prev=p->prev;
	    }
	  else
	    {
	      tail_=p->prev;
	      if(p->prev) p->prev->next=NULL;
	    }

	  delete p;
	  NumElements_--;
	  return;
	}
      p=p->next;
    }
}

//////////////////////////////////////////////////////////////////////////

void List::append(Node* O)
{
  if(head_==NULL)
    {
      head_=new ListElement(O,NULL,NULL);
      tail_=head_;
    }
  else
    {
      tail_->next=new ListElement(O, NULL, tail_);
      tail_=tail_->next;
    }
  NumElements_++;
}

//////////////////////////////////////////////////////////////////////////

ListElement* List::head(void)
{
  return(head_);
}

//////////////////////////////////////////////////////////////////////////

ListElement* List::tail(void)
{
  return(tail_);
}

//////////////////////////////////////////////////////////////////////////

ListElement* List::find(Node *O)
{
  ListElement *p;

  p=head_;
  while(p)
    {
      if(p->data==O)
	{
	  return(p);
	}
      p=p->next;
    }
  return(NULL);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
