//////////////////////////////////////////////////////////////////////////
//
// PriorityQueue.h, Ilja Friedel, 07/16/02
//
//////////////////////////////////////////////////////////////////////////

#ifndef PRIORITYQUEUE
#define PRIORITYQUEUE 1

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <iostream>
#include <math.h>
//#include "List.h"
#include "Set.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class Priority
{
  double priority;
  void*  PQid;

 public:

  bool   is_in_queue(void){return(PQid!=NULL);}

  Priority()
    {
      PQid       = NULL;
      priority   = 0.0;
    }
};

//////////////////////////////////////////////////////////////////////////

class PriorityQueue
{
  friend class Priority;

 public:

  virtual int        size(void)=0;
  virtual void       push(double priority, Priority *P)=0;
  virtual void       update_priority(double priority, Priority *P)=0;
  virtual void       remove(Priority *P)=0;
  virtual Priority*  top(void)=0;
  virtual void       pop(void)=0;
  virtual bool       empty(void)=0;
		       
  virtual           ~PriorityQueue();
};

//////////////////////////////////////////////////////////////////////////

class LogPQueue:public PriorityQueue
{
  Set**  table;
  double max_val, min_val;
  double lcq;
  int    topp;
  int    N, table_size;
  
 public:

  virtual int        size(void);
  virtual void       push(double priority, Priority *P);
  virtual void       update_priority(double priority, Priority *P);
  virtual void       remove(Priority *P);
  virtual Priority*  top(void);
  virtual void       pop(void);
  virtual bool       empty(void);
		       		       
  virtual           ~LogPQueue();
                     LogPQueue(int s, double max_v, double min_v);
};

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#endif
