//////////////////////////////////////////////////////////////////////////
//
// Set.cpp, Ilja Friedel, 06/26/02
//
//////////////////////////////////////////////////////////////////////////

#include "Set.h"
#include "../Mesh/Mesh.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
// ok
Set::~Set()
{
  while(NumElements()>0)
    {
      removeElement();
    }
};

//////////////////////////////////////////////////////////////////////////
// ok
Set::Set()
{
  ptr=NULL;
  NumElements_=0;
}

//////////////////////////////////////////////////////////////////////////

Set::Set(Set *S)
{
  int i;

  i=S->NumElements();
  while(i>0)
    {
      insert(S->Element());
      S->nextElement();
      i--;
    }
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
// ok
void Set::print(void)
{
  Node *N;
  int i;
  
  i=NumElements();
  while(i>0);
    {
      N=Element();
      cout << N->ID << " ";
      nextElement();
      i--;
    }      
  cout << endl;
}

//////////////////////////////////////////////////////////////////////////
// ok?
void Set::removeElement(void)
{
  if(NumElements()==0)
    {
      cerr << "Warning: Trying to removeElement() from empty Set!" << endl;
      return;
    }
  if(NumElements()==1)
    {
      delete ptr;
      prev=ptr=NULL;
      NumElements_=0;
      return;
    }
  if(NumElements()>1)
    {
      prev->next=prev->next->next;
      delete ptr;
      ptr=prev->next;
      NumElements_--;
    }
}
  
//////////////////////////////////////////////////////////////////////////
// ok?
void Set::remove(Node* O)
{
  if(find(O)) removeElement();
}

//////////////////////////////////////////////////////////////////////////
// ok
void Set::insert(Node* O)
{
  if(NumElements()==0)
    {
      ptr=new SetElement(O);
      ptr->next=ptr;
      prev=ptr;
      NumElements_++;
    }
  else
    {
#ifndef NO_MULTIPLE_ELEMENTS
      prev->next=new SetElement(O,ptr);
      ptr=prev->next;
      NumElements_++;
#else
      SetElement* old_prev;
      old_prev=prev;
      if(!find(O))
	{
	  prev->next=new SetElement(O,ptr);
	  ptr=prev->next;
	  NumElements_++;
	  return;
	}
      else
	{
	  cerr << "Warning: Element already found in Set." << endl;
	  cerr << "         [void Set::insert(Node* O)]" << endl;
	}
      prev=old_prev; // making "find"-operation invisible
      ptr =prev->next;
#endif
    }
}

//////////////////////////////////////////////////////////////////////////
// getElement() will be Node *O
// to do

int Set::find(Node *O)
{
  int i;
  SetElement *old_prev;
  
  if(NumElements()==0)
    {
      return(0);
    }

  old_prev=prev;

  i=NumElements();
  while(i>0)
    {
      if(prev->next->data==O)
	{
	  return(1);
	}
      prev=ptr;
      ptr=ptr->next;
      i--;
    }

  prev=old_prev; // just to be safe
  ptr=prev->next;
  return(0);
}

//////////////////////////////////////////////////////////////////////////
// ok
Node* Set::Element(void)
{
  if(NumElements()>0)
    {
      return(ptr->data);
    }
  else
    {
      return(NULL);
    }
}

//////////////////////////////////////////////////////////////////////////
// ok
void Set::nextElement(void)
{
  if(NumElements()>0)
    {
      prev=ptr;
      ptr=ptr->next;
    }
}

//////////////////////////////////////////////////////////////////////////

int Set::ElementOf(Node *O)
{
  SetElement *old_prev;

  old_prev=prev;
  if(find(O))
    {
      prev=old_prev;
      ptr=prev->next;
      return(1);
    }
  prev=old_prev;
  ptr=prev->next;
  return(0);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
