//////////////////////////////////////////////////////////////////////////
//
// Set.h, Ilja Friedel, 06/22/02
//
//////////////////////////////////////////////////////////////////////////

#ifndef SET_DEF
#define SET_DEF

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class Node;

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class SetElement
{
 public:

  Node       *data;
  SetElement *next;

  SetElement(Node *O, SetElement *n=NULL)
    {
      data=O;
      next=n;
    }
};

//////////////////////////////////////////////////////////////////////////

class Set
{
  SetElement  *ptr;
  SetElement  *prev;
  int         NumElements_;

 public:

  // general set operations, no side effects
  void        remove(Node* O);   
  void        insert(Node* O);   
  int         ElementOf(Node *O);
  Node*       Element(void);     
  void        print(void);       
  int         NumElements(void)          
    {
      return(NumElements_);
    }
  
  // special FIFO set operations with side effects
  void        nextElement(void);  // changes Element
  void        removeElement(void);// removes this Element     
  int         find(Node* O);      // sets element to O if found
  
  virtual     ~Set();
              Set();
              Set(Set *S); // copy constructor
};

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#endif
