//////////////////////////////////////////////////////////////////////////
//
// Tree.h, Ilja Friedel, 08/31/02
//
//////////////////////////////////////////////////////////////////////////

#ifndef TREE_DEF
#define TREE_DEF 1

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <iostream>
#include "../Mesh/Mesh.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class Priority2
{
  friend class Tree;

  double priority;
  void*  PQid;

 public:

  bool   is_in_queue(void){return(PQid!=NULL);}

  Priority2()
    {
      PQid       = NULL;
      priority   = 0.0;
    }
};

//////////////////////////////////////////////////////////////////////////

class TreeNode
{
  Priority *data;
  TreeNode *next;
  TreeNode *prev;
  TreeNode *parent;
  TreeNode *lchild;
  //  TreeNode     *rchild; // strange

  int      degree(void);

  friend class Tree;

 public:

  TreeNode(Priority *d=NULL)
    {
      d      = NULL;
      next   = this;
      prev   = this;
      parent = NULL;
      lchild = NULL;
      //      rchild = NULL;
    }

  TreeNode(TreeNode *p, TreeNode *n, Priority *d=NULL)
    {
      d      = NULL;
      next   = n;
      prev   = p;
      parent = NULL;
      lchild = NULL;
      //      rchild = NULL;
    }
};

//////////////////////////////////////////////////////////////////////////

class Tree
{
 protected:

  TreeNode *root;
  int       N;

  TreeNode* insert_root(Priority *P);
  TreeNode* insert_child(TreeNode *TN, Priority *P);
  TreeNode* insert_rsibling(TreeNode *TN, Priority *P);
  void      remove(TreeNode *TN);

  //insert(Priority *P);
  //insert_lsibling(TreeNode *TN, Priority *P);
  //insert_lchild(TreeNode *TN, Priority *P);
  //insert_parent(TreeNode *TN, Priority *P);

 public:
  
  int       size(void);
  int       degree(TreeNode *TN);
  TreeNode* FirstElement(void);
  TreeNode* NextElement(TreeNode *TN); // returns NULL at end

  Tree();
  ~Tree();
};

//////////////////////////////////////////////////////////////////////////

class ZeroTree:public Tree
{

};

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#endif
